
DE_file='$HOME1/rna-seq-pH-1/DE1/deseq1/enrichment1/ds1.comparison.txt'
#outDir='$HOME1/rna-seq-pH-1/DE1/deseq1/enrichment1/goseq_KEGG'
#outDir='$HOME1/rna-seq-pH-1/DE1/deseq1/enrichment1/goseq_GO-trinotate'
outDir='$HOME1/rna-seq-pH-1/DE1/deseq1/enrichment1/goseq_GO-uniprot-stylophora'

title='GO'
#title='KEGG'

column_id='ID'
start=1
end=15

###################

#geneToGo_file='$HOME1/$WD1/data/stylophora-genome/trinotate/trinotate_annotation_report2.txt.geneLevel.GOs_.molten.2.withParents_'
#geneToGo_file='$HOME1/$WD1/data/dbs/kegg/spis.ptw.2.txt'
geneToGo_file='$HOME1/$WD1/data/stylophora-genome/uniprot/uniprot-stylophora.tab.GOs.molten_gene-to-GOterms1.txt'

######################################

function assert_ { rc=$?; if [[ $rc != 0 ]]; then echo 'exit !!!!'; exit $rc; fi }

if [ ! -d "$outDir" ] || [ ! -f "$DE_file" ] ||  [ ! -f "$geneToGo_file" ]; then echo "not all files or directories"; exit; fi
if [ ! -d "$outDir/log" ]; then mkdir "$outDir/log"; assert_; fi

if [ $1 -eq 0 ]; then
    head -n1 "$DE_file"
elif [ $1 -eq 1 ]; then
    for i in $(seq $start $end); do
        echo "i = $i"
        sbatch -o "$outDir/log/$title.$i.out" -e "$outDir/log/$title.$i.err" \
            -p hive1d,hive7d,ckpthp1d,ckpthp7d,ckpthp31d,preempt1d,preempt7d,preempt31d,ckptdell1d,ckptdell7d,ckptdell31d,hiveunlim,queen,ckptqueen \
			--wrap "
            if [ ! -z ${CONDA+x} ]; then
                . \"$CONDA\"; assert_
                conda activate R3.5.1_1
                Rscript goseq_non-natively-supported-108.R \
                --start=$i \
                --end=$i \
                 --outDir=\"$outDir\" \
                --DE_file=\"$DE_file\" \
                --geneToGo_file=\"$geneToGo_file\" \
                --title=\"$title\" \
                --column_id=\"$column_id\" \
                --splitID=\"F\"
                conda deactivate
            else
				echo \"CONDA global variable doesn't exist\"; assert_
			fi
            "
        #break
    done
elif [ $1 -eq 2 ]; then
    
    cd "$outDir"
    summary_file_1_=("$title.goseq_nobias.summary.txt" "$title.goseq_wall.summary.txt")
    search_=("goseq_nobias.txt" "goseq_wall.txt")
    
    for i in "${!summary_file_1_[@]}"; do
        summary_file_1="${summary_file_1_[$i]}"
        search1="${search_[$i]}"
        echo "writing into \"$summary_file_1\" ..."
        if [ -f "$summary_file_1" ]; then rm "$summary_file_1"; fi
        visited=0
        for z in */"$title"*."$search1"; do
            n=$(wc -l "$z" | sed 's/ .*//')
            if [ $n -gt 1 ]; then
                name1=$(echo "$z" | sed 's/.*\///' | sed 's/.goseq_.*//' | perl -ne '$_ =~ s/\.select\.\d+$|^\w+\.//g; printf("%s",$_)')
                echo "$name1"
                if [ $visited -eq 0 ]; then
                    cat "$z" | perl -slane 'chomp; if($. > 1){printf("%s\t%s\n",$name1,$_)}else{printf("%s\t%s\n","comparison",$_)}' -- -name1="$name1" >> "$summary_file_1"
                else
                    cat "$z" | perl -slane 'chomp; if($. > 1){printf("%s\t%s\n",$name1,$_)}' -- -name1="$name1" >> "$summary_file_1"
                fi
                #cat "$z" | perl -slane 'chomp; printf("%s\t%s\t%s\n",$name1,($. > 1 ? "line".($.-1) : "line"),$_)' -- -name1="$name1" >> "$summary_file_1"
                visited=1
            fi
        done
    done
	
    zip -j "$title.goseq_fit.zip" */"$title"*.pdf
fi

