
outdirs[0]='$HOME1/rna-seq-pH-1/filtered/fastqc'
files[0]='*filtered_fastqc.zip'
names[0]='filtered.multiqc'

###########################################################

function assert_ { rc=$?; if [[ $rc != 0 ]]; then echo 'exit !!!!'; exit $rc; fi }

for i in ${!outdirs[@]}; do
    outdir="${outdirs[i]}"
    subdir="${names[i]}"
    files1="${files[i]}"
    echo "$outdir"
    echo "$files1"
    echo "$subdir"
    if [ -d "$outdir" ]; then echo 'OK'; fi
    if [ $1 -eq 1 ]; then
        mkdir "$outdir/$subdir"
        sbatch --mem=128000 -N1 -n20 --ntasks-per-node=20 \
            -o "$outdir/$subdir/multiqc".out -e "$outdir/$subdir/multiqc".err \
            -p hive1d,hive7d,hiveunlim,queen,preempt1d,preempt7d,preempt31d,ckpthp1d,ckpthp7d,ckpthp31d,ckptdell1d,ckptdell7d,ckptdell31d \
                --wrap "
                        function assert_ { rc=\$?; if [[ \$rc != 0 ]]; then echo 'exit !!!!'; exit \$rc; fi }
                        if [ ! -z \${CONDA+x} ]; then
                            . \"\$CONDA\"; assert_
                            conda activate rnaseq_denovo_2; assert_
                            cd \""$outdir/$subdir"\"
                            multiqc ../$files1
                            assert_
                            conda deactivate; assert_
                        else
                            echo \"CONDA global variable doesn't exist\"; assert_
                        fi
                        "
    fi
    echo '------------------'
done
